//This is a controller that is not specific to any view but applies for all views
//I.E.  This receives API push notifications.

var voicePersonalsControllers = angular.module('voicePersonals.controllers');

voicePersonalsControllers.controller('vpApplicationCtrl', function($rootScope, $scope, $timeout, $interval, vpLocalStorage) {

    $scope.color = 'dark';
    $scope.newMessageCount = 0;  //parallel this value with local storage value to detect when no values come in and to allow view binding

    var blinkerOn = false;
    var blinkInterval = null;

    var turnBlinkerOn = function(skip_ui_digest) {
        if (!blinkerOn) {
            $scope.color = 'calm';
            blinkerOn = true;
            blinkInterval = $interval(function () {
                $scope.color = ($scope.color == 'dark') ? 'calm' : 'dark';
            }, 1500);
        }

        if ( ! skip_ui_digest) $scope.$apply();
    }

    $rootScope.setNewMessageReceived = function() {  //invoked by web socket if available so needs angular ui digest invoked
        console.log("Web socket functionality is disabled.  This should not be getting invoked.");
    //     $scope.newMessageCount++;
    //     vpLocalStorage.set('newMessageCount', Number(vpLocalStorage.get('newMessageCount')) + 1)
    //     turnBlinkerOn();
    }

    //this is invoked in several cases: login, app resume, message polling etc to determine if new message indicator should blink
    //note: when blinking is enabled, causes the refresher to automatically execute when user visits inbox.
    $rootScope.checkIfNewMsgReceived = function(new_msg_count) {
        if (Number(vpLocalStorage.get('newMessageCount')) != new_msg_count) {
            if (new_msg_count > 0) turnBlinkerOn(true);
        }
    }

    $rootScope.disableNewMessageAlert = function(resetCount) {
        if (blinkerOn) {
            $interval.cancel(blinkInterval);
            blinkerOn = false;
            $scope.color = 'dark';
        }
        if (resetCount) {
            $scope.newMessageCount = 0;
            vpLocalStorage.set('newMessageCount', 0);
        }
    }

    $rootScope.initNewMsgCount = function(count) {
        $scope.newMessageCount = count;
    }

    $rootScope.storeCurrentMsgCount = function(count) {
        vpLocalStorage.set('newMessageCount', count);
    }

    $rootScope.isNewMessage = function() {
        return blinkerOn;
    }

});