angular.module('voicePersonals.controllers')

.controller('InboxThreadCtrl', function($scope, $state, $stateParams, $ionicPopover, $ionicModal, $rootScope, vpLoading, vpSession, vpInbox, vpReplyHandler, vpMessenger, vpSystemConfirmAction) {

    if (!vpSession.isLoggedIn()) $state.go('tab.login');
    else {

        if (vpInbox.getCurrentInboxView() == 'none') {  //something happened, session lost?, vpInbox is not loaded, goto inbox
            $state.go('tab.inbox');
        }

        var promise = vpInbox.getMessages(false, vpInbox.getCurrentInboxView(), 'retrieve your messages');
        promise.then(function(success) {
            var messageInFocus = null;
            for (var i=0; i < success.length; i++) {
                if (success[i].id == $stateParams.messageID) {
                    messageInFocus = success[i];
                    break;
                }
            }
            if (messageInFocus != null) {
                $scope.messageThread = messageInFocus;
                $scope.messageThreadAudioInFocus = { url: $scope.messageThread.recording_url };  //scope binding for vpLoveMediaPlayer directive
            } else {
                $state.go('tab.inbox');
            }

        });

    }

    //messages options popover
    $scope.replyToType = 'Message';
    $ionicPopover.fromTemplateUrl('templates/reply_options_messages.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.popover = popover;
    });

    $scope.openPopover = function($event) {
        $scope.popover.show($event);
    };
    $scope.closePopover = function() {
        $scope.popover.hide();
    };
    //Cleanup the popover when we're done with it!
    $scope.$on('$destroy', function() {
        $scope.popover.remove();
    });
    // Execute action on hide popover
    $scope.$on('popover.hidden', function() {
        // Execute action
    });
    // Execute action on remove popover
    $scope.$on('popover.removed', function() {
        // Execute action
    });


    //reply to message modal
    $ionicModal.fromTemplateUrl('templates/reply.html', {
        scope: $scope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $scope.modal = modal;
    });
    $scope.replyToMessage = function() {
        $scope.modal.show();
    };
    $scope.closeModal = function() {
        $rootScope.$broadcast('replyToPersonalCanceled', {});
        $scope.modal.hide();
    };
    //Cleanup the modal when we're done with it!
    $scope.$on('$destroy', function() {
        $scope.modal.remove();
    });
    // Execute action on hide modal
    $scope.$on('modal.hidden', function() {
        // Execute action
    });
    // Execute action on remove modal
    $scope.$on('modal.removed', function() {
        // Execute action
    });

    //reply to message completed
    $scope.maxRecordingLength = 30;
    $scope.replyMessage = {};  //object binding for reply input form.
    $scope.replyRecordingCompleted = function(filename) {

        $scope.replyMessage.respondingToMessageID = $stateParams.messageID;
        var replyPromise = vpReplyHandler.handleReply($scope, filename, $scope.replyMessage);

        replyPromise.then(function(success) { //display success message, redirect and refresh inbox
            $scope.showSystemMessage('Message Sent', 'Message Sent Successfully.', 'success', 'tab.inbox', 'Close', {refresh: 1});
        });

    }

    //delete message
    $scope.deleteMessage = function() {
        var del_promise = vpMessenger.deleteMessage($stateParams.messageID);
        del_promise.then(function(success) {
            var refresh_promise = vpInbox.getMessages(true, vpInbox.getCurrentInboxView(), 'refresh your inbox after successfully deleting the message');
            refresh_promise.then(function(success) {
                $state.go('tab.inbox');
            });
        });
    }

    $scope.blockUser = function() {

        var userConfirmedPromise = vpSystemConfirmAction.showSystemConfirmation('Block User', 'Are you sure you want to block this user?');

        userConfirmedPromise.then(function(success) {
            var block_promise = vpMessenger.blockUser($scope.messageThread['from_account_id']);
            block_promise.then(function (success) {
                vpInbox.setNewMessagesCount();
                $state.go('tab.inbox', {refresh: 1});
            });

        }, function(userCancelled) {
            //console.log("user cancelled.");
            ;
        });

    }

});