
angular.module('voicePersonals.controllers')

.controller('InboxCtrl', function($scope, $state, $stateParams, $ionicPopover, $rootScope, vpSession, vpInbox, vpSystemMessage) {

    $scope.setInboxView = function(view, forceRefresh, broadcastRefreshComplete) {

        if ($rootScope.isNewMessage()) forceRefresh = true; //force update on user request or new message available
        var promise = vpInbox.getMessages(forceRefresh, view, 'retrieve your messages');
        promise.then(function(success) {

            for (i =0; i < success.length; i++) {

                if (success[i].personal_image_link.indexOf('default_male') > 0)
                    success[i].gender_icon = 'fa-mars';
                else if (success[i].personal_image_link.indexOf('default_couple') > 0)
                    success[i].gender_icon = 'fa-venus-mars';
                else
                    success[i].gender_icon = 'fa-venus';

            }
            $scope.messages = success;
            $scope.isMessages = (Object.keys($scope.messages).length > 0) ? true : false;
            vpInbox.setCurrentInboxView(view);
            if (view == 'new') $rootScope.disableNewMessageAlert();
            if (broadcastRefreshComplete) $scope.$broadcast('scroll.refreshComplete');  //informs ion-refresher directive that the refresh is completed.
        });

    };

    if (!vpSession.isLoggedIn()) $state.go('tab.login');
    else {
        vpSystemMessage.get();
        var forceRefresh = ($stateParams.refresh == 1) ? true : false;
        var currentView = (vpInbox.getCurrentInboxView() == 'none') ? 'new' : vpInbox.getCurrentInboxView();
        $scope.setInboxView(currentView, forceRefresh, false);
    }

    $scope.refreshInbox = function() {
        $scope.setInboxView(vpInbox.getCurrentInboxView(), true, true);
    };

    $scope.getViewNameDisplay = function() {
        return vpInbox.getCurrentInboxViewDisplayName();
    }


    //Inbox view options.
    $ionicPopover.fromTemplateUrl('templates/inbox-options.html', {
        scope: $scope
    }).then(function (popover) {
        $scope.popover = popover;
    });

    $scope.openPopover = function ($event) {
        $scope.popover.show($event);
    };
    $scope.closePopover = function () {
        $scope.popover.hide();
    };
    //Cleanup the popover when we're done with it!
    $scope.$on('$destroy', function () {
        if ($scope.popover !== undefined) $scope.popover.remove();
    });
    // Execute action on hide popover
    $scope.$on('popover.hidden', function () {
        // Execute action
    });
    // Execute action on remove popover
    $scope.$on('popover.removed', function () {
        // Execute action
    });

});
