angular.module('voicePersonals.controllers')

.controller('ProfileCtrl', function($scope, $state, $timeout, vpLoading, vpProfile, $ionicPopover, vpAccount, vpSession, vpInbox, vpWebSocket, vpPoller, vpGeolocation, vpLocalStorage) {

    if (!vpSession.isLoggedIn()) $state.go('tab.login');  //this can occur after logging out then pressing the back button.
    else {
        vpProfile.get().then(function(profile) {
            $scope.profile = profile;
            $scope.profileRecording = {url: $scope.profile.recording_url};

            if (vpLocalStorage.get('GPSPermissionRequestedAlready') != 'yes') {  //only ask once
                vpLocalStorage.set('GPSPermissionRequestedAlready', 'yes');
                if ( ! (parseInt($scope.profile.geoposition_id) > 0)) {
                    vpGeolocation.getLocation().then(function(data) {
                        vpGeolocation.uploadLocation(data).then(function(result) {
                            if (result.data && typeof result.data.error == 'undefined') {
                                vpProfile.get(false, true).then(function(profile_w_loc) {
                                    //using angular $timeout so I don't have to call $apply directly, was receiving digest already in progress error.
                                    $timeout(function() { $scope.profile = profile_w_loc; });
                                });
                            } else console.log("An error occurred uploading geolocation: ", result.data.error);
                        });
                    }, function(error) {
                        //ignore error and let the user continue on to view profile.
                        console.log("There was an error requesting users geolocation: ", error);
                    });
                }
            }
        });
    }

    $scope.logout = function() {
        var logoutPromise = vpAccount.logout();
        logoutPromise.then(function(success) {
            vpSession.logout();
            vpInbox.handleLogout();
            vpProfile.logout();
            // vpWebSocket.close();
            vpPoller.stopPolling();
            $state.go('tab.login', {}, {location: 'replace'});  //replace does not seem to work here, so have to do profile undefined case above
        });
    };

    //account options hover box that displays when logged in
    $ionicPopover.fromTemplateUrl('templates/account_options.html', {
        scope: $scope
    }).then(function(popover) {
        $scope.popover = popover;
    });

    $scope.openPopover = function($event) {
        $scope.popover.show($event);
    };
    $scope.closePopover = function() {
        $scope.popover.hide();
    };
    //Cleanup the popover when we're done with it!
    $scope.$on('$destroy', function() {
        if ($scope.popover !== undefined) $scope.popover.remove();
    });
    // Execute action on hide popover
    $scope.$on('popover.hidden', function() {
        // Execute action
    });
    // Execute action on remove popover
    $scope.$on('popover.removed', function() {
        // Execute action
    });
});