var services_module = angular.module('voicePersonals.services');

services_module.factory('vpAudioRecorder', function ($q, $timeout) {

    var mediaRec = null;
    var maxRecordingTimeout = null;

    return {

        recordAudio: function($max_secs_length) {

            if (typeof $max_secs_length === 'undefined') $max_secs_length = 10;

            var q = $q.defer();
            var src = "audiorecording.amr";
            mediaRec = new Media(
                src,
                function() {  // success callback
                    q.resolve(src);
                },
                function(err) { // error callback
                    console.log("Media constructor failed with error: ", err);
                    q.reject("Media startRecord failed with error code: "+err.code+".");
                },
                function(status) {
                    console.log("Media status change detected: ", status);
                }
            );

                mediaRec.startRecord();  // Record audio

            maxRecordingTimeout = $timeout(function() {
                mediaRec.stopRecord();
            }, $max_secs_length * 1000);

            return q.promise;
        },

        finishAudioRecording: function() {
            $timeout.cancel(maxRecordingTimeout);
            mediaRec.stopRecord();
            mediaRec.release();
        }
    };
});
