var voice_personals_services_module = angular.module('voicePersonals.services');


voice_personals_services_module.factory('vpGeolocation', function($q, vpConfig, vpHTTP) {

    return {
        getLocation: function (source, path, trustAllHosts, options) {
            var q = $q.defer();
            navigator.geolocation.getCurrentPosition(function(position) {
                    q.resolve(position);
                },
                function(error) {
                    q.reject(error);
                },
                {maximumAge: 60000});  //accept cache value for a minute

            return q.promise;
        },

        uploadLocation: function(geoposition) {
            var url = vpConfig.baseAPIURL() + '/api/personal/setLocInfo';
            var postData = {latitude: geoposition.coords.latitude, longitude: geoposition.coords.longitude};
            // console.log("uploading geoposition: ", geoposition, postData);
            return vpHTTP.post(url, postData, 'store your location')
        }
    }
});
