var voice_personals_services_module = angular.module('voicePersonals.services');


/********************************************************
 *
 *  Implements HTML5 LocalStorage.
 *
 *  http://www.w3.org/TR/webstorage/
 *
 *  Note: This storage persists across browser windows.
 *  The storage also persist after all browsers are closed and re-opened.
 *
 *  This means data persists between cordova application stops and starts.
 *  This data will also persist on application updates and upgrades.
 *
 *  Local storage will be cleared in cordova when the user manually uninstalls the app or manually clears the stored data.
 *
 *  Note:  At least on chrome, In-Privacy Mode (Cntl + Shift + N) will create an isolated localstorage.
 *  So local storage will not be maintained across private and non-private chrome usage.
 *
 ********************************************************/


voice_personals_services_module.factory('vpLocalStorage', function($window) {

    return {


        set: function(key, value) {
            $window.localStorage[key] = value;
        },

        get: function(key) {
            return $window.localStorage[key];
        }
    }
});