var services_module = angular.module('voicePersonals.services');

services_module.factory('vpMedia', function ($q) {

    return {

        newMedia: function (src, success, error, status) {
            return new Media(src, success, error, status);
        },

        getCurrentPosition: function (source) {
            var q = $q.defer();

            source.getCurrentPosition(function (success) {
                q.resolve(success);
            }, function (error) {
                q.reject(error);
            });

            return q.promise;
        },

        getDuration: function(source) {

            var counter = 0;
            var deferred = $q.defer();

            var timerDur = setInterval(function() {
                counter = counter + 100;
                if (counter > 20000) {
                    clearInterval(timerDur);
                    deferred.resolve('-2');
                }
                var tempDur = source.getDuration();
                if (tempDur > 0) {
                    clearInterval(timerDur);
                    deferred.resolve(tempDur);
                }
            }, 100);

            return deferred.promise;
        },

        play: function (source) {
            source.play();

            // iOS quirks :
            // -  myMedia.play({ numberOfLoops: 2 }) -> looping
            // -  myMedia.play({ playAudioWhenScreenIsLocked : false })
        },

        pause: function (source) {
            return source.pause();
        },

        release: function (source) {
            return source.release();
        },

        seekTo: function (source, milliseconds) {

            return source.seekTo(milliseconds);
        },

        setVolume: function (source, volume) {
            return source.setVolume(volume);
        },

        startRecord: function (source) {
            return source.startRecord();
        },

        stopRecord: function (source) {

            return source.stopRecord();
        },

        stop: function (source) {
            return source.stop();
        }
    }
});