
var voice_personals_services_module = angular.module('voicePersonals.services');

voice_personals_services_module.factory('vpPersonalFilters', function(vpProfile, vpConfig) {


    var filterData = {authorGender: 'all', seekingGender: 'all', type: 'all', location: 'all'};  //current filters, init'd to default values, directly linked to browse personals scope.
    var filterLabels = {authorGender: 'All', 'seekingGender': 'All', 'type': 'All', 'location': 'All'};  //current filter labels as displayed on filter menu

    var authorGenderOptions = [{label: 'Show All', value: 'all', db_id: 0}, {label: 'Men', value: 'men', db_id: 1}, {label: 'Women', value: 'women', db_id: 2}, {label: 'Couples', value: 'couple', db_id: 3}];
    var typeOptions = vpConfig.getCategoryFilters();

    return {

        getCurrentFilters: function() {
            return filterData;
        },

        getFilterLabels: function() {
            return filterLabels;
        },

        //perhaps I could refactor so client no longer needs to set this?  This should update automatically whenever the current filters change.
        setFilterLabel: function(filter_type, label) {
            filterLabels[filter_type] = label;
        },

        getAuthorGenders: function() {
            return authorGenderOptions;
        },

        getRelationshipTypeOptions: function() {
            return typeOptions;
        },

        initFilters: function() {  //invoked after login to initialize starting filters
            vpProfile.get().then(function(profile) {   //set author gender filter and seeking gender filters based on user's profile
                authorGenderOptions.forEach(function(genderObject) {
                    if (genderObject.db_id == profile.seeking_gender_id) {
                        filterData.authorGender = genderObject.value;
                        filterLabels['authorGender'] = genderObject.label;
                    }
                    if (genderObject.db_id == profile.author_gender_id) {
                        filterData.seekingGender = genderObject.value;
                        filterLabels['seekingGender'] = genderObject.label;
                    }
                });
            });
        }
    }
});