/*
 * This is AJAX poller to fall back on if browser does not have web socket support
 */

var voice_personals_services_module = angular.module('voicePersonals.services');

voice_personals_services_module.factory('vpPoller', function($interval, vpInbox) {

    var polling_interval_promise = null;

    var pollNewMessagesCount = function() {
        // console.log("polling message count");
        vpInbox.setNewMessagesCount(true);
    }

    return {
        startPolling: function() {
            if (polling_interval_promise == null) {
                // console.log("polling started");
                polling_interval_promise = $interval(pollNewMessagesCount, 300000)   //poll for new message count every 5 minutes
            }

        },

        stopPolling: function() {

            if (polling_interval_promise != null) {
                // console.log("stopping interval");
                $interval.cancel(polling_interval_promise);
                polling_interval_promise = null;
            }

        }
    }

});