var voice_personals_services_module = angular.module('voicePersonals.services');

voice_personals_module.factory('vpProfile', function(vpConfig, vpHTTP, $q) {

    var profile = null;

    return {

        get: function (webSocketConnectReq, force) {

            var profileDefer = $q.defer();

            if (profile == null || force) {

                //Do not redirect to login on no session state when web socket connection is trying to be established.
                //This occurs on every app resume, so can be run without being logged in.
                //disable login redirect so that age verification flow does not get interrupted.
                var redirectToLogin = (webSocketConnectReq === true) ? true : false;

                var url = vpConfig.baseAPIURL() + '/api/personal/getPersonals';
                vpHTTP.get(url, 'get your profile', false, redirectToLogin).then(function(success) {

                    if (typeof success.data.errors !== 'undefined' && success.data.errors[0] == 'no profile') {
                        profileDefer.resolve("no profile");
                    } else {
                        profile = success.data;
                        profileDefer.resolve(profile);
                    }

                }, function(error) {
                    profileDefer.reject("Error getting profile.  Not logged in?");
                });

            } else {
                profileDefer.resolve(profile);
            }

            return profileDefer.promise;
        },

        upload: function (personal) {
            var url = vpConfig.baseAPIURL() + '/api/personal/savePersonal';
            return vpHTTP.post(url, personal, 'create your personal');
        },

        userHasProfile: function() {
            return profile != null;
        },

        logout: function() {
            profile = null;
        }
    }
});