var voice_personals_services_module = angular.module('voicePersonals.services');


voice_personals_services_module.factory('vpReplyHandler', function($q, vpLoading, vpAudioUploader, vpMessenger) {  //this might actually probably be better as a directive?

    var instance = this;

    this.defaultTitle = 'Personal Voice Message';
    this.personalsResponded = [];

    return {

        handleReply:  function($scope, filename, replyMessage) {

            vpLoading.showLoading();

            var deferred = $q.defer();

            //upload the audio file
            var promise = vpAudioUploader.uploadAudio(filename);
            promise.then(function(recordingURL) {

                vpLoading.hideLoading();

                if (!replyMessage.title) replyMessage.title = instance.defaultTitle;

                replyMessage.recordingURL = recordingURL;
                promise = vpMessenger.upload(replyMessage);
                promise.then(function(success) {
                    $scope.closeModal();
                    replyMessage.title = null;  //reset so placeholder functionality works
                    deferred.resolve("success");
                }, function(error) {
                    $scope.closeModal();
                    replyMessage.title = null;  //reset so placeholder functionality works
                    deferred.reject("error occurred.  no inbox update needed.'");
                });
            }, function (error) {
                vpLoading.hideLoading();
                $scope.closeModal();
                $scope.showSystemMessage('Error', "An error occurred uploading your voice recording.  Please try again later.", 'error');
                deferred.reject("audio upload failed.  no inbox update needed");
            });

            return deferred.promise;

        }
    };
});