var voice_personals_services_module = angular.module('voicePersonals.services');

voice_personals_services_module.factory('vpSession', function($http, vpLocalStorage) {

    return {

        set: function(vpTokenToSet) {  //this changes the current session token (if exists),  Only invoked on login.
            $http.defaults.headers.common.Authorization = 'VoicePersonals '+vpTokenToSet;
            vpLocalStorage.set('loggedIn', 'true');
            vpLocalStorage.set('vpSessionToken', vpTokenToSet);   //should store encrypted in db storage engine?
        },

        refreshLogin: function() {  //this re-enables logged in session using currently stored token (app resume, sw update etc)
            if (vpLocalStorage.get('loggedIn') == 'true')
                $http.defaults.headers.common.Authorization = 'VoicePersonals '+this.getToken();
        },

        isLoggedIn: function() {
            return (vpLocalStorage.get('loggedIn') == 'true');
        },

        logout: function() {
            vpLocalStorage.set('loggedIn', 'false');
        },

        getToken: function() {
            return vpLocalStorage.get('vpSessionToken');
        }
    }
});
