var voice_personals_services_module = angular.module('voicePersonals.services');


voice_personals_services_module.factory('vpSystemMessage', function($rootScope, $ionicModal, $state, $sce) {  //this might actually probably be better as a directive?

    $rootScope.systemMessageTransitionState = null;
    $rootScope.systemMessageTitle = '';
    $rootScope.systemMessage = '';
    $rootScope.systemMessageButtonText = '';

    //reply to message modal
    $ionicModal.fromTemplateUrl('templates/system_message.html', {
        scope: $rootScope,
        animation: 'slide-in-up'
    }).then(function(modal) {
        $rootScope.systemMessageModal = modal;
    });

    return {
        get: function() {

            $rootScope.showSystemMessage = function(title, message, type, transition_to_state, button_text, transition_params) {

                if ($rootScope.systemMessageModal.isShown() === false) {

                    $rootScope.systemMessageTitle = title;
                    $rootScope.systemMessage = $sce.trustAsHtml(message);

                    if (type == 'error') $rootScope.systemMessageIcon = 'ion-sad';
                    else if (type == 'success') $rootScope.systemMessageIcon = 'ion-happy';
                    else if (type == 'blocked') $rootScope.systemMessageIcon = 'ion-android-hand';

                    if (typeof(transition_to_state) !== 'undefined') {
                        $rootScope.systemMessageTransitionState = transition_to_state;
                        $rootScope.systemMessageTransitionStateParams = transition_params;
                    }
                    else {
                        $rootScope.systemMessageTransitionState = null;
                        $rootScope.systemMessageTransitionStateParams = null;
                    }

                    if (button_text) $rootScope.systemMessageButtonText = button_text;
                    else $rootScope.systemMessageButtonText = 'Close';

                    $rootScope.systemMessageModal.show();
                }

            };
            $rootScope.closeSystemMessage = function() {
                $rootScope.systemMessageModal.hide();
            };
            //Cleanup the modal when we're done with it!
            $rootScope.$on('$destroy', function() {
                $rootScope.systemMessageModal.remove();
            });
            // Execute action on hide modal
            $rootScope.$on('modal.hidden', function() {
                if ($rootScope.systemMessageTransitionState !== null) {
                    var transitionState = $rootScope.systemMessageTransitionState;
                    var transitionParams = $rootScope.systemMessageTransitionStateParams;
                    $rootScope.systemMessageTransitionState = null;
                    $rootScope.systemMessageTransitionStateParams = null;
                    $state.go(transitionState, transitionParams);
                }
            });
            // Execute action on remove modal
            $rootScope.$on('modal.removed', function() {
                // Execute action
            });
        }
    }
});
